Index: issm/trunk/src/m/classes/timestepping.m
===================================================================
--- issm/trunk/src/m/classes/timestepping.m	(revision 27035)
+++ issm/trunk/src/m/classes/timestepping.m	(revision 27232)
@@ -5,9 +5,10 @@
 
 classdef timestepping
-	properties (SetAccess=public) 
+	properties (SetAccess=public)
 		start_time      = 0.;
 		final_time      = 0.;
 		time_step       = 0.;
 		interp_forcing  = 1;
+		average_forcing  = 0;
 		cycle_forcing   = 0;
 		coupling_time   = 0.;
@@ -32,4 +33,5 @@
 			fielddisplay(self,'time_step',['length of time steps [' unit ']']);
 			fielddisplay(self,'interp_forcing','interpolate in time between requested forcing values? (0 or 1)');
+			fielddisplay(self,'average_forcing','average in time if there are several forcing values between steps? (0 or 1, default is 0)');
 			fielddisplay(self,'cycle_forcing','cycle through forcing? (0 or 1)');
 			fielddisplay(self,'coupling_time',['length of coupling time step with ocean model [' unit ']']);
@@ -46,4 +48,5 @@
 			%should we interpolate forcing between timesteps?
 			self.interp_forcing=1;
+			self.average_forcing=0;
 			self.cycle_forcing=0;
 		end % }}}
@@ -54,8 +57,9 @@
 			md = checkfield(md,'fieldname','timestepping.time_step','numel',[1],'>=',0,'NaN',1,'Inf',1);
 			md = checkfield(md,'fieldname','timestepping.interp_forcing','numel',[1],'values',[0 1]);
+			md = checkfield(md,'fieldname','timestepping.average_forcing','numel',[1],'values',[0 1]);
 			md = checkfield(md,'fieldname','timestepping.cycle_forcing','numel',[1],'values',[0 1]);
 			if self.final_time-self.start_time<0,
 				md = checkmessage(md,'timestepping.final_time should be larger than timestepping.start_time');
-			end 
+			end
 			if strcmp(solution,'TransientSolution'),
 				md = checkfield(md,'fieldname','timestepping.time_step','numel',[1],'>',0,'NaN',1,'Inf',1);
@@ -70,13 +74,15 @@
 			WriteData(fid,prefix,'object',self,'fieldname','time_step','format','Double','scale',scale);
 			WriteData(fid,prefix,'object',self,'fieldname','interp_forcing','format','Boolean');
+			WriteData(fid,prefix,'object',self,'fieldname','average_forcing','format','Boolean');
 			WriteData(fid,prefix,'object',self,'fieldname','cycle_forcing','format','Boolean');
 			WriteData(fid,prefix,'object',self,'fieldname','coupling_time','format','Double','scale',scale);
 		end % }}}
 		function savemodeljs(self,fid,modelname) % {{{
-		
+
 			writejsdouble(fid,[modelname '.timestepping.start_time'],self.start_time);
 			writejsdouble(fid,[modelname '.timestepping.final_time'],self.final_time);
 			writejsdouble(fid,[modelname '.timestepping.time_step'],self.time_step);
 			writejsdouble(fid,[modelname '.timestepping.interp_forcing'],self.interp_forcing);
+			writejsdouble(fid,[modelname '.timestepping.average_forcing'],self.interp_forcing);
 			writejsdouble(fid,[modelname '.timestepping.cycle_forcing'],self.cycle_forcing);
 
Index: issm/trunk/src/m/classes/timestepping.py
===================================================================
--- issm/trunk/src/m/classes/timestepping.py	(revision 27035)
+++ issm/trunk/src/m/classes/timestepping.py	(revision 27232)
@@ -11,9 +11,10 @@
     """
 
-    def __init__(self, *args): #{{{
+    def __init__(self, *args):  #{{{
         self.start_time = 0
         self.final_time = 0
         self.time_step = 0
         self.interp_forcing = 1
+        self.average_forcing = 0
         self.cycle_forcing = 0
         self.coupling_time = 0
@@ -24,5 +25,6 @@
             raise RuntimeError('constructor not supported')
     #}}}
-    def __repr__(self): #{{{
+
+    def __repr__(self):  #{{{
         s = '   timestepping parameters:\n'
         unit = 'yr'
@@ -31,9 +33,11 @@
         s += '{}\n'.format(fielddisplay(self, 'time_step', 'length of time steps [' + unit + ']'))
         s += '{}\n'.format(fielddisplay(self, 'interp_forcing', 'interpolate in time between requested forcing values? (0 or 1)'))
+        s += '{}\n'.format(fielddisplay(self, 'average_forcing', 'average in time if there are several forcing values between steps? (0 or 1, default is 0)'))
         s += '{}\n'.format(fielddisplay(self, 'cycle_forcing', 'cycle through forcing? (0 or 1)'))
         s += '{}\n'.format(fielddisplay(self, 'coupling_time', 'length of coupling time steps with ocean model [' + unit + ']'))
         return s
     #}}}
-    def setdefaultparameters(self): #{{{
+
+    def setdefaultparameters(self):  #{{{
         # Time between 2 time steps
         self.time_step = 1 / 2
@@ -44,12 +48,16 @@
         # Should we interpolate forcing between timesteps?
         self.interp_forcing = 1
+        self.average_forcing = 0
         self.cycle_forcing = 0
 
         return self
     #}}}
-    def checkconsistency(self, md, solution, analyses): #{{{
+
+    def checkconsistency(self, md, solution, analyses):  #{{{
         md = checkfield(md, 'fieldname', 'timestepping.start_time', 'numel', [1], 'NaN', 1, 'Inf', 1)
         md = checkfield(md, 'fieldname', 'timestepping.final_time', 'numel', [1], 'NaN', 1, 'Inf', 1)
         md = checkfield(md, 'fieldname', 'timestepping.time_step', 'numel', [1], '>=', 0, 'NaN', 1, 'Inf', 1)
+        md = checkfield(md, 'fieldname', 'timestepping.interp_forcing', 'numel', [1], 'values', [0, 1])
+        md = checkfield(md, 'fieldname', 'timestepping.average_forcing', 'numel', [1], 'values', [0, 1])
         md = checkfield(md, 'fieldname', 'timestepping.cycle_forcing', 'numel', [1], 'values', [0, 1])
         if (self.final_time - self.start_time) < 0:
@@ -60,5 +68,6 @@
         return md
     #}}}
-    def marshall(self, prefix, md, fid): #{{{
+
+    def marshall(self, prefix, md, fid):  #{{{
         scale = md.constants.yts
         WriteData(fid, prefix, 'name', 'md.timestepping.type', 'data', 1, 'format', 'Integer')
@@ -67,4 +76,5 @@
         WriteData(fid, prefix, 'object', self, 'fieldname', 'time_step', 'format', 'Double', 'scale', scale)
         WriteData(fid, prefix, 'object', self, 'fieldname', 'interp_forcing', 'format', 'Boolean')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'average_forcing', 'format', 'Boolean')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'cycle_forcing', 'format', 'Boolean')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'coupling_time', 'format', 'Double', 'scale', scale)
Index: issm/trunk/src/m/classes/timesteppingadaptive.m
===================================================================
--- issm/trunk/src/m/classes/timesteppingadaptive.m	(revision 27035)
+++ issm/trunk/src/m/classes/timesteppingadaptive.m	(revision 27232)
@@ -5,5 +5,5 @@
 
 classdef timesteppingadaptive
-	properties (SetAccess=public) 
+	properties (SetAccess=public)
 		start_time      = 0.;
 		final_time      = 0.;
@@ -11,6 +11,7 @@
 		time_step_max   = 0.;
 		cfl_coefficient = 0.;
-		interp_forcing = 1;
-		cycle_forcing = 1;
+		interp_forcing  = 1;
+		average_forcing = 0;
+		cycle_forcing   = 1;
 		coupling_time   = 0.;
 	end
@@ -40,4 +41,5 @@
 			%should we interpolate forcing between timesteps?
 			self.interp_forcing=1;
+			self.average_forcing=0;
 			self.cycle_forcing=0;
 		end % }}}
@@ -50,9 +52,10 @@
 			md = checkfield(md,'fieldname','timestepping.cfl_coefficient','numel',[1],'>',0,'<=',1);
 			md = checkfield(md,'fieldname','timestepping.interp_forcing','numel',[1],'values',[0 1]);
+			md = checkfield(md,'fieldname','timestepping.average_forcing','numel',[1],'values',[0 1]);
 			md = checkfield(md,'fieldname','timestepping.cycle_forcing','numel',[1],'values',[0 1]);
 			md = checkfield(md,'fieldname','timestepping.coupling_time','numel',[1],'>=',md.timestepping.coupling_time,'NaN',1,'Inf',1);
 			if self.final_time-self.start_time<0,
 				md = checkmessage(md,'timestepping.final_time should be larger than timestepping.start_time');
-			end 
+			end
 		end % }}}
 		function disp(self) % {{{
@@ -66,4 +69,5 @@
 			fielddisplay(self,'cfl_coefficient','coefficient applied to cfl condition');
 			fielddisplay(self,'interp_forcing','interpolate in time between requested forcing values ? (0 or 1)');
+			fielddisplay(self,'average_forcing','average in time if there are several forcing values between steps? (0 or 1, default is 0)');
 			fielddisplay(self,'cycle_forcing','cycle through forcing ? (0 or 1)');
 			fielddisplay(self,'coupling_time',['coupling time step with ocean model [' unit ']']);
@@ -80,9 +84,10 @@
 			WriteData(fid,prefix,'object',self,'class','timestepping','fieldname','cfl_coefficient','format','Double');
 			WriteData(fid,prefix,'object',self,'class','timestepping','fieldname','interp_forcing','format','Boolean');
+			WriteData(fid,prefix,'object',self,'class','timestepping','fieldname','average_forcing','format','Boolean');
 			WriteData(fid,prefix,'object',self,'class','timestepping','fieldname','cycle_forcing','format','Boolean');
 			WriteData(fid,prefix,'object',self,'class','timestepping','fieldname','coupling_time','format','Double','scale',scale);
 		end % }}}
 		function savemodeljs(self,fid,modelname) % {{{
-		
+
 			writejsdouble(fid,[modelname '.timesteppingadaptive.start_time'],self.start_time);
 			writejsdouble(fid,[modelname '.timesteppingadaptive.final_time'],self.final_time);
@@ -91,4 +96,5 @@
 			writejsdouble(fid,[modelname '.timesteppingadaptive.cfl_coefficient'],self.cfl_coefficient);
 			writejsdouble(fid,[modelname '.timesteppingadaptive.interp_forcing'],self.interp_forcing);
+			writejsdouble(fid,[modelname '.timesteppingadaptive.average_forcing'],self.interp_forcing);
 			writejsdouble(fid,[modelname '.timesteppingadaptive.cycle_forcing'],self.cycle_forcing);
 			writejsdouble(fid,[modelname '.timesteppingadaptive.coupling_time'],self.time_step_max);
Index: issm/trunk/src/m/classes/timesteppingadaptive.py
===================================================================
--- issm/trunk/src/m/classes/timesteppingadaptive.py	(revision 27035)
+++ issm/trunk/src/m/classes/timesteppingadaptive.py	(revision 27232)
@@ -20,4 +20,5 @@
             self.cfl_coefficient = 0.
             self.interp_forcing = 1
+            self.average_forcing = 0
             self.cycle_forcing = 0
             self.coupling_time = 0.
@@ -33,4 +34,5 @@
             self.final_time = old.final_time
             self.interp_forcing = old.interp_forcing
+            self.average_forcing = old.average_forcing
             self.cycle_forcing = old.cycle_forcing
             self.coupling_time = old.coupling_time
@@ -42,12 +44,13 @@
     def __repr__(self):  # {{{
         string = "   timesteppingadaptive parameters:"
-        string = "%s\n%s" % (string, fielddisplay(self, "start_time", "simulation starting time [yr]"))
-        string = "%s\n%s" % (string, fielddisplay(self, "final_time", "final time to stop the simulation [yr]"))
-        string = "%s\n%s" % (string, fielddisplay(self, "time_step_min", "minimum length of time steps [yr]"))
-        string = "%s\n%s" % (string, fielddisplay(self, "time_step_max", "maximum length of time steps [yr]"))
-        string = "%s\n%s" % (string, fielddisplay(self, "cfl_coefficient", "coefficient applied to cfl condition"))
-        string = "%s\n%s" % (string, fielddisplay(self, "interp_forcing", "interpolate in time between requested forcing values ? (0 or 1)"))
-        string = "%s\n%s" % (string, fielddisplay(self, "cycle_forcing", "cycle through forcing ? (0 or 1)"))
-        string = "%s\n%s" % (string, fielddisplay(self, "coupling_time", "coupling time steps with ocean model [yr]"))
+        string = '{}\n{}'.format (string, fielddisplay(self, "start_time", "simulation starting time [yr]"))
+        string = '{}\n{}'.format(string, fielddisplay(self, "final_time", "final time to stop the simulation [yr]"))
+        string = '{}\n{}'.format (string, fielddisplay(self, "time_step_min", "minimum length of time steps [yr]"))
+        string = '{}\n{}'.format (string, fielddisplay(self, "time_step_max", "maximum length of time steps [yr]"))
+        string = '{}\n{}'.format (string, fielddisplay(self, "cfl_coefficient", "coefficient applied to cfl condition"))
+        string = '{}\n{}'.format (string, fielddisplay(self, "interp_forcing", "interpolate in time between requested forcing values ? (0 or 1)"))
+        string = '{}\n{}'.format(string, fielddisplay(self, 'average_forcing', 'average in time if there are several forcing values between steps? (0 or 1, default is 0)'))
+        string = '{}\n{}'.format(string, fielddisplay(self, "cycle_forcing", "cycle through forcing ? (0 or 1)"))
+        string = '{}\n{}'.format(string, fielddisplay(self, "coupling_time", "coupling time steps with ocean model [yr]"))
         return string
     # }}}
@@ -63,4 +66,5 @@
         #should we interpolate forcing between timesteps?
         self.interp_forcing = 1
+        self.average_forcing = 0
         self.cycle_forcing   = 0
         return self
@@ -76,4 +80,5 @@
             md.checkmessage("timestepping.final_time should be larger than timestepping.start_time")
         md = checkfield(md, 'fieldname', 'timestepping.interp_forcing', 'numel', [1], 'values', [0, 1])
+        md = checkfield(md, 'fieldname', 'timestepping.average_forcing', 'numel', [1], 'values', [0, 1])
         md = checkfield(md, 'fieldname', 'timestepping.cycle_forcing', 'numel', [1], 'values', [0, 1])
         md = checkfield(md, 'fieldname', 'timestepping.coupling_time', 'numel', [1], '>=', 0, 'NaN', 1, 'Inf', 1)
@@ -91,4 +96,5 @@
         WriteData(fid, prefix, 'object', self, 'class', 'timestepping', 'fieldname', 'cfl_coefficient', 'format', 'Double')
         WriteData(fid, prefix, 'object', self, 'class', 'timestepping', 'fieldname', 'interp_forcing', 'format', 'Boolean')
+        WriteData(fid, prefix, 'object', self, 'class', 'timestepping', 'fieldname', 'average_forcing', 'format', 'Boolean')
         WriteData(fid, prefix, 'object', self, 'class', 'timestepping', 'fieldname', 'cycle_forcing', 'format', 'Boolean')
         WriteData(fid, prefix, 'object', self, 'class', 'timestepping', 'fieldname', 'coupling_time', 'format', 'Double', 'scale', yts)
Index: issm/trunk/src/m/classes/transient.js
===================================================================
--- issm/trunk/src/m/classes/transient.js	(revision 27035)
+++ issm/trunk/src/m/classes/transient.js	(revision 27232)
@@ -9,4 +9,5 @@
 
 		//full analysis: Stressbalance, Masstransport and Thermal but no groundingline migration for now
+		this.isage             = 0;
 		this.issmb             = 1;
 		this.ismasstransport   = 1;
@@ -32,4 +33,5 @@
 		console.log(sprintf('   transient solution parameters:'));
 
+		fielddisplay(this,'isage','indicates whether age model is requested in the transient');
 		fielddisplay(this,'issmb','indicates whether a surface mass balance solution is used in the transient');
 		fielddisplay(this,'ismasstransport','indicates whether a masstransport solution is used in the transient');
@@ -58,4 +60,5 @@
 			if (solution!='TransientSolution') return;
 
+			checkfield(md,'fieldname','transient.isage','numel',[1],'values',[0, 1]);
 			checkfield(md,'fieldname','transient.issmb','numel',[1],'values',[0, 1]);
 			checkfield(md,'fieldname','transient.ismasstransport','numel',[1],'values',[0, 1]);
@@ -77,4 +80,5 @@
 
 			prefix='md.transient';
+			WriteData(fid,prefix,'object',this,'fieldname','isage','format','Boolean');
 			WriteData(fid,prefix,'object',this,'fieldname','issmb','format','Boolean');
 			WriteData(fid,prefix,'object',this,'fieldname','ismasstransport','format','Boolean');
@@ -112,4 +116,5 @@
 	// {{{
 
+	this.isage             = 0;
 	this.issmb             = 0;
 	this.ismasstransport   = 0;
Index: issm/trunk/src/m/classes/transient.m
===================================================================
--- issm/trunk/src/m/classes/transient.m	(revision 27035)
+++ issm/trunk/src/m/classes/transient.m	(revision 27232)
@@ -6,4 +6,5 @@
 classdef transient
 	properties (SetAccess=public) 
+		isage             = 0;
 		issmb             = 0;
 		ismasstransport   = 0;
@@ -34,4 +35,5 @@
 
 			%full analysis: Stressbalance, Masstransport and Thermal but no groundingline migration for now
+			self.isage             = 0;
 			self.issmb             = 0;
 			self.ismasstransport   = 0;
@@ -55,4 +57,5 @@
 
 			%full analysis: Stressbalance, Masstransport and Thermal but no groundingline migration for now
+			self.isage             = 0;
 			self.issmb             = 1;
 			self.ismasstransport   = 1;
@@ -85,4 +88,5 @@
 			if ~strcmp(solution,'TransientSolution'), return; end
 
+			md = checkfield(md,'fieldname','transient.isage','numel',[1],'values',[0 1]);
 			md = checkfield(md,'fieldname','transient.issmb','numel',[1],'values',[0 1]);
 			md = checkfield(md,'fieldname','transient.ismasstransport','numel',[1],'values',[0 1]);
@@ -111,4 +115,5 @@
 			disp(sprintf('   transient solution parameters:'));
 
+			fielddisplay(self,'isage','indicates whether an age model is used in the transient');
 			fielddisplay(self,'issmb','indicates whether a surface mass balance solution is used in the transient');
 			fielddisplay(self,'ismasstransport','indicates whether a masstransport solution is used in the transient');
@@ -129,4 +134,5 @@
 		end % }}}
 		function marshall(self,prefix,md,fid) % {{{
+			WriteData(fid,prefix,'object',self,'fieldname','isage','format','Boolean');
 			WriteData(fid,prefix,'object',self,'fieldname','issmb','format','Boolean');
 			WriteData(fid,prefix,'object',self,'fieldname','ismasstransport','format','Boolean');
@@ -155,4 +161,5 @@
 		function savemodeljs(self,fid,modelname) % {{{
 		
+			writejsdouble(fid,[modelname '.trans.isage'],self.isage);
 			writejsdouble(fid,[modelname '.trans.issmb'],self.issmb);
 			writejsdouble(fid,[modelname '.trans.ismasstransport'],self.ismasstransport);
Index: issm/trunk/src/m/classes/transient.py
===================================================================
--- issm/trunk/src/m/classes/transient.py	(revision 27035)
+++ issm/trunk/src/m/classes/transient.py	(revision 27232)
@@ -12,4 +12,5 @@
 
     def __init__(self):  # {{{
+        self.isage = 0
         self.issmb = 0
         self.ismasstransport = 0
@@ -33,4 +34,5 @@
     def __repr__(self):  # {{{
         s = '   transient solution parameters:\n'
+        s += '{}\n'.format(fielddisplay(self, 'isage', 'indicates if age model is requested in the transient'))
         s += '{}\n'.format(fielddisplay(self, 'issmb', 'indicates if a surface mass balance solution is used in the transient'))
         s += '{}\n'.format(fielddisplay(self, 'ismasstransport', 'indicates if a masstransport solution is used in the transient'))
@@ -59,4 +61,5 @@
 
     def deactivateall(self):  #{{{
+        self.isage = 0
         self.issmb = 0
         self.ismasstransport = 0
@@ -82,4 +85,5 @@
         # Full analysis: Stressbalance, Masstransport and Thermal but no 
         # groundingline migration for now
+        self.isage = 0
         self.issmb = 1
         self.ismasstransport = 1
@@ -107,4 +111,5 @@
             return md
 
+        md = checkfield(md, 'fieldname', 'transient.isage', 'numel', [1], 'values', [0, 1])
         md = checkfield(md, 'fieldname', 'transient.issmb', 'numel', [1], 'values', [0, 1])
         md = checkfield(md, 'fieldname', 'transient.ismasstransport', 'numel', [1], 'values', [0, 1])
@@ -130,4 +135,5 @@
 
     def marshall(self, prefix, md, fid):  # {{{
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'isage', 'format', 'Boolean')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'issmb', 'format', 'Boolean')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'ismasstransport', 'format', 'Boolean')
Index: issm/trunk/src/m/contrib/defleurian/paraview/exportVTK.py
===================================================================
--- issm/trunk/src/m/contrib/defleurian/paraview/exportVTK.py	(revision 27035)
+++ issm/trunk/src/m/contrib/defleurian/paraview/exportVTK.py	(revision 27232)
@@ -29,8 +29,22 @@
     Basile de Fleurian:
     '''
+    #verbosity of the code, 0 is no messages, 5 is chatty
+    verbose = 0
+
+    print("""
+    =========================================
+    #     A                                 #
+    #    / \      exportVTK is now obsolete #
+    #   / | \     You should use export VTU #
+    #  /  |  \    faster, smaller files     #
+    # /   o   \   and more capacities       #
+    # ---------                             #
+    #========================================
+    """)
+
 
     for key in kwargs.keys():
         if key not in ['clipping', 'coarsetime', 'singletime']:
-            raise BadOption('Provided option "{}" is not supported possibilities are : {}'.format(key, ['cliping', 'coarsetime']))
+            raise BadOption('Provided option "{}" is not supported possibilities are : {}'.format(key, ['cliping', 'coarsetime', 'singletime']))
 
     if 'coarsetime' in kwargs.keys() and 'singletime' in kwargs.keys():
@@ -56,5 +70,6 @@
 
     # this is the result structure {{{
-    print('Getting accessorie variables')
+    if verbose > 3:
+        print('Getting accessorie variables')
     res_struct = md.results
     moving_mesh = False
@@ -80,9 +95,15 @@
 
     # get the element related variables {{{
-    print('Now treating  the mesh')
+    if verbose > 3:
+        print('Now treating  the mesh')
     #first get the general things
     dim = int(md.mesh.domaintype()[0])
     every_nodes = md.mesh.numberofvertices
     every_cells = md.mesh.numberofelements
+    try:
+        every_edges = md.mesh.numberofedges
+    except AttributeError:
+        #3D meshes do not have edges
+        every_edges = 0
 
     if np.shape(md.mesh.elements)[1] == 3 or enveloppe:
@@ -103,4 +124,6 @@
             convert_index = np.nan * np.ones(np.shape(md.mesh.x))
             convert_index = np.asarray([[i, np.where(enveloppe_index == i)[0][0]] for i, val in enumerate(convert_index) if any(enveloppe_index == i)])
+
+            num_of_points = np.size(enveloppe_index)
             points = np.column_stack((md.mesh.x[enveloppe_index],
                                       md.mesh.y[enveloppe_index],
@@ -114,5 +137,8 @@
                 connect[elt, 2] = convert_index[np.where(convert_index == connect[elt, 2])[0], 1][0]
 
-            num_of_points = np.size(enveloppe_index)
+            num_of_edges = every_edges  #looks like edges is only defined on the 2d mesh
+            if num_of_edges > 0:
+                edges = md.mesh.edges[:, 0:2].reshape(int(num_of_edges), 2) - 1
+
         else:
             raise BadDimension("exportVTK can't get an enveloppe for  dimension {}".format(dim))
@@ -122,4 +148,7 @@
         num_of_elt = every_cells
         connect = md.mesh.elements - 1
+        num_of_edges = every_edges
+        if num_of_edges > 0:
+            edges = md.mesh.edges[:, 0:2].reshape(int(num_of_edges), 2) - 1
         enveloppe_index = np.arange(0, np.size(md.mesh.x))
         num_of_points = every_nodes
@@ -129,5 +158,6 @@
                                         2 : md.geometry.base
                                         3 : md.geometry.bed
-                                        4 : 0\n''')
+                                        4 : 0
+                                        5 : Custom\n''')
             if mesh_alti == '1':
                 points = np.column_stack((md.mesh.x, md.mesh.y, md.geometry.surface))
@@ -138,4 +168,11 @@
             elif mesh_alti == '4':
                 points = np.column_stack((md.mesh.x, md.mesh.y, 0. * md.mesh.x))
+            elif mesh_alti == '5':
+                alti_field = input("Which field should be used as 3rd dimension: ")
+                alti_var = eval(alti_field)
+                if np.shape(np.squeeze(alti_var)) == np.shape(md.mesh.x):
+                    points = np.column_stack((md.mesh.x, md.mesh.y, np.squeeze(alti_var)))
+                else:
+                    raise BadDimension('field given for 3rd dimension should be defined on vertices {} is not.'.format(alti_field))
             else:
                 points = np.column_stack((md.mesh.x, md.mesh.y, md.geometry.surface))
@@ -166,4 +203,5 @@
             clip_convert_index = np.nan * np.ones(np.shape(points)[0])
 
+            #define the vertices that are within clipping window
             Inclipping = np.intersect1d(InX, InY)
             Isinside[Inclipping] = True
@@ -171,4 +209,5 @@
             num_of_points = np.shape(points)[0]
 
+            #go thorough the elements and keep those for which one node is in the clipped arrea
             clipconnect = np.asarray([], dtype=int)
             for elt in connect:
@@ -176,4 +215,5 @@
                     clipconnect = np.append(clipconnect, elt, axis=0)
 
+            #reshape
             num_of_elt = int(np.size(clipconnect) / 3)
             connect = clipconnect.reshape(num_of_elt, 3)
@@ -181,4 +221,6 @@
             clip_convert_index = np.asarray([[i, np.where(Inclipping == i)[0][0]] for i, val in enumerate(clip_convert_index) if any(Inclipping == i)])
             enveloppe_index = enveloppe_index[clip_convert_index[:, 0]]
+
+            #convert indexing and exclude elements that are partly outside of the region
             for elt in range(0, num_of_elt):
                 try:
@@ -198,7 +240,30 @@
             num_of_elt = np.shape(connect)[0]
 
+            if num_of_edges > 0:
+                clipedges = np.asarray([], dtype=int)
+                for edge in edges:
+                    if set(edge).issubset(Inclipping):
+                        clipedges = np.append(clipedges, edge, axis=0)
+
+                num_of_edges = int(np.size(clipedges) / 2)
+                edges = clipedges.reshape(num_of_edges, 2)
+
+                for edge in range(0, num_of_edges):
+                    try:
+                        edges[edge, 0] = clip_convert_index[np.where(clip_convert_index == edges[edge, 0])[0], 1][0]
+                    except IndexError:
+                        edges[edge, 0] = -1
+                    try:
+                        edges[edge, 1] = clip_convert_index[np.where(clip_convert_index == edges[edge, 1])[0], 1][0]
+                    except IndexError:
+                        edges[edge, 1] = -1
+                edges = edges[np.where(edges != -1)[0], :]
+                num_of_edges = np.shape(edges)[0]
+
     # }}}
+
     # write header and mesh {{{
-    print('Now starting to write stuff')
+    if verbose > 3:
+        print('Now starting to write stuff')
 
     if 'coarsetime' in kwargs.keys():
